LPARAMETERS logrd, lcName, lnColumn
logrd.ADDPROPERTY(EVL(lcName,'aLaXl'), CREATEOBJECT('aLaXl', logrd, lcName, lnColumn))

*--------------------------------------------------------------------------------
* Grid a la Excel
*     (Ctrl+Z),  
*--------------------------------------------------------------------------------
*   :
* Count -  
*
*--------------------------------------------------------------------------------

DEFINE CLASS aLaXl AS CUSTOM
	ScrollDirection = ''
	ScrollType = 0
	RECNO=1
	NewDraw=.T.
	TimerLevel=0
	ScrollBug=.F.
	OldDrawSeconds=0



	ALLOWADDNEW = .T.
	COUNT=0
	fButton = 'CTRL+Z'
	fLabelsButton = 'F10'

	FirstrecnoFlag = 2

	Firstrecno=0
	Lastrecno=0
	OldFirstRecno=0
	OldLastRecno=0
	lnActiveSeconds=0

	lnDynamicColumn =0
	loForm=.F.
	logrd=.F.
	loColumn = .F.

	DIMENSION CHANGES(1,6)
	ColumnSparse=.T.
	PROCESS = .F.
	NAME = 'aLaXl'
	UniqueID=''
	UseLabels = .F.
	loLabels = .F.

	UsePatches = .F.
	loPatches = .F.

	FUNCTION LanchTimer
		LOCAL lo,lnLine
		THIS.TimerLevel=THIS.TimerLevel+1
		lnCount=0
		FOR lnLine=THIS.OBJECTS.COUNT TO 1 STEP -1
			lo=THIS.OBJECTS(lnLine)
			IF LEFT(lo.NAME,5)='Timer'
				THIS.REMOVEOBJECT(lo.NAME)
			ENDIF

		NEXT
		lo=.F.
		THIS.ADDOBJECT('Timer'+ALLTRIM(STR(THIS.TimerLevel)),'OneTimeTimer',THIS.TimerLevel,SECONDS())


	FUNCTION INIT
		LPARAMETERS logrd, lcName, lnColumn
		WITH THIS
			IF TYPE('logrd.RecordSource')='C'
				IF EMPTY(.UniqueID)
					.UniqueID = SYS(2015)
				ENDIF
				.logrd = logrd
				.loForm = ObjForm(logrd)
				IF NOT EMPTY(lcName)
					.NAME = lcName
				ENDIF
				BINDEVENT(.logrd, 'txtLostFocus', THIS,'StoreChanges',1)
				BINDEVENT(.logrd, 'MouseWheel', THIS,'MouseWheel',1)

				BINDEVENT(.logrd, 'AfterRowColChange', THIS,'AfterRowColChange',1)
				BINDEVENT(.logrd, 'Resize', THIS,'AFTERROWCOLCHANGE',1)
				FOR EACH loColumn IN .logrd.COLUMNS
					BINDEVENT(loColumn,'Resize', THIS,'AFTERROWCOLCHANGE',1)
					BINDEVENT(loColumn,'Visible', THIS,'AFTERROWCOLCHANGE',1)
				NEXT

				BINDEVENT(.logrd, 'Scrolled', THIS,'Scrolled',1)
				BINDEVENT(.logrd, 'SetFocus', THIS,'ActivateGrid',1)
				BINDEVENT(.logrd, 'Destroy', THIS,'Destroy')
				BINDEVENT(.loForm,'Release', THIS,'Destroy')

				lnColumn=EVL(lnColumn,1)
				.loColumn= logrd.COLUMNS(lnColumn)
				.ActivateGrid()
			ENDIF
		ENDWITH


	FUNCTION AFTERROWCOLCHANGE
		LPARAMETERS nColIndex

		WITH THIS
			lnDynamicColumn=FirstGridColumn(.logrd)
			IF .lnDynamicColumn # lnDynamicColumn
				IF .lnDynamicColumn>0
					.logrd.COLUMNS(.lnDynamicColumn).DYNAMICFONTOUTLINE=''
				ENDIF
				.lnDynamicColumn = lnDynamicColumn
				IF .lnDynamicColumn>0
					.logrd.COLUMNS(.lnDynamicColumn).FONTSIZE = .logrd.COLUMNS(.lnDynamicColumn).FONTSIZE
					.logrd.COLUMNS(.lnDynamicColumn).DYNAMICFONTOUTLINE=TEXTMERGE([this.aLaXl.GetFirstRecno()])
				ENDIF
			ENDIF
			IF .lnDynamicColumn>0
				.logrd.COLUMNS(.lnDynamicColumn).FONTSIZE = .logrd.COLUMNS(.lnDynamicColumn).FONTSIZE
			ENDIF
			.NewDraw = .T.
		ENDWITH

*
*	 
*
	FUNCTION 
		LOCAL lnLine
		FOR lnLine=1 TO THIS.COUNT
			THIS.Ctrlz()
		NEXT

	FUNCTION ActivateGrid
		IF NOT THIS.PROCESS	&&      
			ON KEY LABEL (THIS.fButton) DO On_CtrlZ IN aLaXl
			THIS.AFTERROWCOLCHANGE(101)
		ENDIF

	FUNCTION DeActivateGrid
		IF NOT THIS.PROCESS	&&      
			ON KEY LABEL (THIS.fButton)
		ENDIF

	FUNCTION 
		WITH THIS
			IF .logrd.RELATIVEROW>0
				RETURN
			ENDIF
			lnRowFrom = MROW(.loForm.NAME,3)
			lnColumnFrom=MCOL(.loForm.NAME,3)
			lnRowTo = obj2Client(.logrd,1)+.logrd.HEADERHEIGHT+.logrd.ROWHEIGHT/2+1
			lnColumnTo=obj2Client(.logrd,2)+3
			IF .ScrollDirection='Up'
				lnRowCount = GetGridRowCount(.logrd)
				lnRowTo = lnRowTo + (lnRowCount-1) * .logrd.ROWHEIGHT
			ENDIF
			MOUSE CLICK AT lnRowTo, lnColumnTo DRAG TO lnRowFrom, lnColumnFrom PIXELS WINDOW (.loForm.NAME) LEFT
		ENDWITH


	FUNCTION MOUSEWHEEL
		LPARAMETERS nDirection, nShift, nXCoord, nYCoord
		THIS.ScrollDirection=IIF(nDirection>0,'Up','Down')
		THIS.ScrollType=1

***********************
*		SCROLLED
***********************
	FUNCTION SCROLLED
		LPARAMETERS nDirection
		LOCAL lnScrollType, lnTop

		WITH THIS
			IF EMPTY(.ScrollDirection)
				.ScrollDirection=ICASE(INLIST(nDirection,0,2),'Up',INLIST(nDirection,1,3),'Down','')
				IF nDirection>1
					.ScrollType=1
				ELSE
					lnTop=obj2Client(.logrd,1)
					IF BETWEEN(MROW(.loForm.NAME,3), lnTop+SYSMETRIC(6)+1, lnTop+.logrd.HEIGHT-SYSMETRIC(6) - IIF(.logrd.SCROLLBARS=3,SYSMETRIC(14) , 0))
						.ScrollType=2
					ELSE
						.ScrollType=1
					ENDIF
				ENDIF

			ENDIF


			.NewDraw=.T.
			.ClearAllMarks()
			.()
			.ScrollDirection=''
			.ScrollType=0

			.SetMarks()
		ENDWITH

*
*	SetMarks -  ""
*
	FUNCTION SetMarks
		LPARAMETERS lp1,lp2, lp3, lnTimerLevel
		n0=SECONDS()
		LOCAL lcField, lcName, 	;
			llLock, llUseLabels, 	;
			lnChangeCount, lnColumn, lnColumnCount, lnColumns, lnCount, lnCount1, lnCurrentRecno, lnGrdRowCount, lnGrdTop, lnLabelsCount, lnLeft, lnLine, lnRight, 	;
			lo, loColumn

		WITH THIS
			IF TYPE('.loForm.Name') # 'C'
				RETURN
			ENDIF

			IF NOT EMPTY(lnTimerLevel) AND lnTimerLevel # .TimerLevel
				RETURN
			ENDIF

			IF .OldFirstRecno=.Firstrecno AND .OldLastRecno=.Lastrecno AND NOT EMPTY(lnTimerLevel)
				RETURN
			ENDIF
			.OldFirstRecno=.Firstrecno
			.OldLastRecno=.Lastrecno
			.ClearAllMarks()

			llLock=.loForm.LOCKSCREEN
			.loForm.LOCKSCREEN=.T.
			lnGrdRowCount = INT(GetGridRowCount(.logrd))
			lnColumns=0
			FOR EACH loColumn IN .logrd.COLUMNS
				IF NOT loColumn.VISIBLE OR EMPTY(obj2Client(loColumn,3))
					LOOP
				ENDIF
				lnColumns=lnColumns+1
				LOCAL laColumns(lnColumns,4)
				laColumns(lnColumns,1)=VAL(SUBSTR(loColumn.NAME,7))
				laColumns(lnColumns,2)=obj2Client(loColumn,2)
				laColumns(lnColumns,3)=obj2Client(loColumn,3)
				laColumns(lnColumns,4)=JustSource(loColumn)
			NEXT
			SELECT (.logrd.RECORDSOURCE)
			lnCurrentRecno=RECNO()

			lnGrdTop=obj2Client(.logrd,1)+.logrd.HEADERHEIGHT
			STORE 0 TO lnCount, lnCount1, lnLine

			IF NOT EMPTY(lnTimerLevel) AND lnTimerLevel # .TimerLevel
				.loForm.LOCKSCREEN=llLock
				RETURN
			ENDIF
			GO .Firstrecno
			llUseLabels = .UseLabels AND TYPE('.loLabels.COUNT')#'U'

			DO WHILE NOT EOF()
				IF NOT EMPTY(lnTimerLevel) AND lnTimerLevel # .TimerLevel
					.ClearAllMarks()
					EXIT
				ENDIF
				lnLine = lnLine + 1
				FOR lnColumnCount=1 TO lnColumns
					lnColumn = laColumns(lnColumnCount,1)
					lnLeft=laColumns(lnColumnCount,2)
					lnWidth = laColumns(lnColumnCount,3)
					lnRight=lnLeft+lnWidth
					lcField = laColumns(lnColumnCount,4)

					FOR lnChangeCount=.COUNT TO 1 STEP -1
						IF .CHANGES(lnChangeCount,1)=RECNO() AND lnColumn==.CHANGES(lnChangeCount,2)
							lnCount=lnCount+1
							lcName=.UniqueID+totext(lnCount)
							IF TYPE('.loForm.'+lcName)='U'
								.loForm.ADDOBJECT(lcName,'ChangeMark')
							ENDIF
							lo=GETPEM(.loForm,lcName)

							lo.TOP = lnGrdTop + (lnLine-1)* .logrd.ROWHEIGHT+1
							lo.LEFT= lnLeft
							lo.lnColumn = lnColumn
							lo.TOOLTIPTEXT=RTRIM(totext(.CHANGES(lnChangeCount,3)))
							lo.RECNO=RECNO()
							lo.aLaXl = THIS
							EXIT
						ENDIF
					NEXT
					IF .UsePatches
						.loPatches.BindPatches(lnColumn,lnLine, EVALUATE(lcField),lnGrdTop, lnLeft, lnWidth)
					ENDIF
					IF llUseLabels
						FOR lnLabelsCount=1 TO .loLabels.COUNT
							IF .loLabels.Labels(lnLabelsCount,1)=RECNO() AND lcField==.loLabels.Labels(lnLabelsCount,2)
								lnCount1=lnCount1+1
								lcName=.loLabels.UniqueID+totext(lnCount1)
								IF TYPE('.loForm.'+lcName)='U'
									.loForm.ADDOBJECT(lcName,'LabelsMark')
								ENDIF
								lo=GETPEM(.loForm,lcName)
								lo.TOP = lnGrdTop + (lnLine-1)* .logrd.ROWHEIGHT+1
								lo.LEFT= lnRight - lo.WIDTH
								lo.lnColumn = lnColumn
								lo.RECNO=RECNO()
								lo.MyParent = .loLabels
								lo.MyLabel = RTRIM(totext(.loLabels.Labels(lnLabelsCount,3)))
								lo.lnIndex=lnLabelsCount
								EXIT
							ENDIF
						NEXT
					ENDIF
				NEXT
				SKIP
				IF lnLine>=lnGrdRowCount
					EXIT
				ENDIF
			ENDDO
			IF EMPTY(lnTimerLevel) OR lnTimerLevel = .TimerLevel
				IF .UsePatches
					.loPatches.BindPatches(.F.)
				ENDIF
			ENDIF

			IF BETWEEN(lnCurrentRecno,1,RECCOUNT(.logrd.RECORDSOURCE))
				GO lnCurrentRecno IN (.logrd.RECORDSOURCE)
			ENDIF

			.loForm.LOCKSCREEN=llLock

		ENDWITH


	FUNCTION GetFirstRecno
		IF TYPE('THIS.logrd.Name')#'C' OR EOF(THIS.logrd.RECORDSOURCE) &&    Destroy, ..    
			RETURN
		ENDIF
		IF SECONDS() > THIS.OldDrawSeconds+.05
			THIS.NewDraw=.T.
		ENDIF
		THIS.lnActiveSeconds=SECONDS()
		lnRecno=RECNO(THIS.logrd.RECORDSOURCE)
		DO CASE
			CASE THIS.NewDraw
				THIS.NewDraw=.F.
				STORE lnRecno TO THIS.Firstrecno, THIS.Lastrecno

				THIS.LanchTimer()
			CASE THIS.Firstrecno=lnRecno
			OTHERWISE
				THIS.Firstrecno=MIN(THIS.Firstrecno,lnRecno)
				THIS.Lastrecno=MAX(THIS.Lastrecno,lnRecno)
		ENDCASE
		THIS.OldDrawSeconds=SECONDS()

	FUNCTION ClearChanges
		THIS.COUNT=0
		THIS.ClearChangeMarks

	FUNCTION ClearAllMarks
		WITH THIS
			=.ClearChangeMarks() + IIF(.UseLabels,.ClearChangeMarks(1,.loLabels.UniqueID),0) ;
				+ IIF(.UsePatches,.loPatches.BindPatches(.T.),0)
		ENDWITH

	FUNCTION ClearChangeMarks
		LPARAMETERS lnFrom, lcUniqueID
		LOCAL lcName, lnLine
		WITH THIS
			lcUniqueID = EVL(lcUniqueID,.UniqueID)
			FOR lnLine=EVL(lnFrom,1) TO 1000
				lcName=lcUniqueID+totext(lnLine)
				IF TYPE('.loForm.'+lcName)='U'
					EXIT
				ENDIF
				.loForm.REMOVEOBJECT(lcName)
			NEXT
		ENDWITH
		RETURN 0
*
*	   
*
	FUNCTION Ctrlz
		LOCAL lnCount, loTxt
		WITH THIS
*CtrlZ for this value
			IF THIS.logrd.ACTIVECOLUMN!=0
				IF TYPE([this.loGrd.columns(this.loGrd.activecolumn).Controls(2).value])=TYPE([this.loGrd.columns(this.loGrd.activecolumn).Controls(2).oldvalue])
					IF THIS.logrd.COLUMNS(THIS.logrd.ACTIVECOLUMN).CONTROLS(2).VALUE!=THIS.logrd.COLUMNS(THIS.logrd.ACTIVECOLUMN).CONTROLS(2).oldvalue
						THIS.logrd.COLUMNS(THIS.logrd.ACTIVECOLUMN).CONTROLS(2).VALUE=THIS.logrd.COLUMNS(THIS.logrd.ACTIVECOLUMN).CONTROLS(2).oldvalue
						RETURN .F.
					ENDIF
				ENDIF
			ENDIF

*Other cases
			IF .COUNT>0
				.PROCESS=.T.
				DO FORM warn
				SELECT (.logrd.RECORDSOURCE)
				GO .CHANGES(.COUNT,1) IN (.logrd.RECORDSOURCE)
				loTxt = .logrd.COLUMNS(.CHANGES(.COUNT,2))
				loTxt.SETFOCUS
				loTxt = EVALUATE('loTxt.'+loTxt.CURRENTCONTROL)
				IF EMPTY(.logrd.RELATIVEROW)
					.logrd.SETFOCUS
				ENDIF

				loTxt.SETFOCUS
				loTxt.VALUE=.CHANGES(.COUNT,3)
				lnCount=.COUNT - 1
				.logrd.TxtLostFocus(loTxt)
				loTxt.oldvalue=loTxt.VALUE

				.COUNT=lnCount
				.AFTERROWCOLCHANGE
				.PROCESS=.F.
			ENDIF
		ENDWITH

	FUNCTION StoreChanges
		LPARAMETERS lp1,lp2
		LOCAL lnColumn, loTxt
		loTxt = THIS.logrd.loTxt
		IF TYPE('loTxt.Value')='U' OR Equal(loTxt.VALUE,loTxt.oldvalue ) OR THIS.PROCESS OR TYPE('this.logrd.name') # 'C'
			RETURN
		ENDIF
		lnColumn = VAL(SUBSTR(loTxt.PARENT.NAME,7))
		WITH THIS
			IF .COUNT>0 AND .CHANGES(.COUNT,1)=RECNO(.logrd.RECORDSOURCE)	;
					AND .CHANGES(.COUNT,2)=lnColumn	;
					AND .CHANGES(.COUNT,3)=loTxt.oldvalue		;
					AND .CHANGES(.COUNT,4)=loTxt.VALUE
				RETURN
			ENDIF
			.COUNT=.COUNT+1
			DIMENSION .CHANGES(.COUNT,6)
			.CHANGES(.COUNT,1)=RECNO(.logrd.RECORDSOURCE)
			.CHANGES(.COUNT,2)=lnColumn
			.CHANGES(.COUNT,3)=loTxt.oldvalue
			.CHANGES(.COUNT,4)=loTxt.VALUE
			.CHANGES(.COUNT,5)=TIME()
			.CHANGES(.COUNT,6)=IIF(UPPER(loTxt.BASECLASS)='COMBOBOX',loTxt.DISPLAYVALUE,'')
		ENDWITH


	FUNCTION DESTROY
		WITH THIS
			.ClearChangeMarks()
			.DeActivateGrid()
			.Labels(.F.)
			.loPatches=.F.
			STORE .F. TO .logrd, .loForm, .loColumn
			CLEAR CLASS 'aLaXl'
			CLEAR CLASS 'ChangeMark'
		ENDWITH

	FUNCTION Labels
		LPARAMETERS lcUniqueID, lcLabelsTable, lcLabelsCursor,lcNativeTable, lcNativeCursor
		WITH THIS
			IF PCOUNT()=1 AND VARTYPE(lcUniqueID)='L' AND NOT lcUniqueID	&& 
				.UseLabels=.F.
				.loLabels=.F.
				ON KEY LABEL (.fLabelsButton)
				RETURN
			ENDIF
			.loLabels = CREATEOBJECT('Labels')
			.UseLabels=.T.
			WITH .loLabels
				IF EMPTY(.UniqueID)
					.UniqueID = SYS(2015)
				ENDIF
				.MyParent = THIS
				.NativeTable = EVL(lcNativeTable, IIF(TYPE('THIS.logrd.BackDbf')='C',THIS.logrd.BackDbf,''))
				.NativeCursor = EVL(lcNativeCursor, THIS.logrd.RECORDSOURCE)
				.LabelsTable= EVL(lcLabelsTable, ''+.NativeTable)
				.LabelsCursor=EVL(lcLabelsCursor ,'w'+.LabelsTable)
				.START()
			ENDWITH

			ON KEY LABEL  (.fLabelsButton) DO On_F10 IN aLaXl
		ENDWITH

	FUNCTION Patches
		LPARAMETERS lcColumnList
		WITH THIS
			IF PCOUNT()=1 AND VARTYPE(lcColumnList)='L' AND NOT lcColumnList	&& 
				.UsePatches=.F.
				.loPatches=.F.
				IF TYPE('.loPatches.Name')='C'
					.MyParent = .F.
				ENDIF
				RETURN
			ENDIF
			.UsePatches=.T.
			.loPatches = CREATEOBJECT('Patches')
			.loPatches.MyParent = THIS
			.loPatches.ColumnList = lcColumnList
		ENDWITH
ENDDEFINE

DEFINE CLASS ChangeMark AS IMAGE
	PICTURE = 'Xlmark2.gif'
	RECNO=0
	lnColumn=0
	aLaXl=''
	oldvalue=.F.

	FUNCTION INIT
		THIS.VISIBLE=.T.

	FUNCTION MOUSEENTER
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		=Balloon(THIS,THIS.TOOLTIPTEXT ,' ',12,1,5)
	FUNCTION MOUSELEAVE
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		IF TYPE('thisForm.Balloon.Title') = 'C'
			THISFORM.Balloon=.F.
		ENDIF

ENDDEFINE
*
*	 Labels -   
*
DEFINE CLASS Labels AS CUSTOM
	Altered = .F.
	DB='Data'
	MyParent = .F.
	UniqueIDList = 'ID'
	NativeTable = ''
	NativeCursor = ''
	LabelsTable = ''
	LabelsCursor = ''
	UniqueID=''
	LocateExp=''
	COUNT = 0
	DIMENSION Labels(1,6)

	FUNCTION START
		WITH THIS
			.LocateExp = TEXTMERGE([ALLTRIM(<<.LabelsCursor>>.ID)==<<CONCAT(.UniqueIDList)>>])
			.CreateLabelsTable()
			.GetValues()
			.MyParent.AFTERROWCOLCHANGE()
		ENDWITH

	FUNCTION DESTROY
		IF THIS.Altered
			THIS.SAVE()
		ENDIF
		CLEAR CLASS 'Labels'
		CLEAR CLASS 'LabelsMark'


	FUNCTION SAVE
		LOCAL ID, lcFor, lcSql, lcTable, lnLine, lnSelect, lnRecno
		WITH THIS
			lnSelect=SELECT()
			lcTable=.LabelsTable
			lcCursor=.LabelsCursor
			lcFor = 'ID=.Labels(lnLine,5) and Field=.Labels(lnLine,2)'
			lcSql=TEXTMERGE('Select *,RECNO() as Recno from labels\<<.LabelsTable>> into curs <<lcCursor>>')
			&lcSql
			SELECT (lcCursor)
			FOR lnLine=1 TO .COUNT
				m.ID=.Labels(lnLine,5)
				LOCATE FOR &lcFor
				IF FOUND()
					lnRecno=EVALUATE(lcCursor+'.recno')
					IF .Labels(lnLine,4)>TIMESTAMP
						GO lnRecno IN (.LabelsTable)
						REPLACE MyLabels WITH .Labels(lnLine,3), TIMESTAMP WITH .Labels(lnLine,4) IN (.LabelsTable)
					ENDIF
				ELSE
					APPEND BLANK IN (.LabelsTable)
					REPLACE ID WITH m.ID, FIELD WITH .Labels(lnLine,2), ;
						MyLabels WITH .Labels(lnLine,3), TIMESTAMP WITH .Labels(lnLine,4) IN (.LabelsTable)
				ENDIF
			NEXT
			USE IN (.LabelsTable)
			.COUNT=0
			SELECT(lnSelect)
		ENDWITH


	FUNCTION CreateLabelsTable
		LOCAL lc
		WITH THIS
			IF NOT DIRECTORY('Labels')
				MD Labels
			ENDIF
			IF FILE('Labels\'+.LabelsTable+'.dbf')
				RETURN
			ENDIF
			lc ='Labels\'+.LabelsTable+'.dbf'
			CREATE TABLE &lc (ID C(64),FIELD C(12),MyLabels M, TIMESTAMP T)
			USE
		ENDWITH


	FUNCTION GetValues
		LPARAMETERS lcTable,lnRegions
		LOCAL lcFor, lcSql, lnSelect
		WITH THIS
			lnRecno=RECNO(.NativeCursor)
			lnSelect=SELECT()
			lcFor = .LocateExp
			lcSql=TEXTMERGE('Select * from labels\<<.LabelsTable>> into curs <<.LabelsCursor>>')
			&lcSql
			SELECT (.LabelsCursor)
			.COUNT=0
			SCAN FOR NOT EMPTY(MyLabels)
				m.Field=LOWER(ALLTRIM(FIELD))
				m.MyLabels=MyLabels
				m.TimeStamp=TIMESTAMP
				SELECT (.NativeCursor)
				LOCATE FOR &lcFor

				IF FOUND()
					.COUNT=.COUNT+1
					DIMENSION .Labels(.COUNT,6)
					.Labels(.COUNT,1)=RECNO()
					.Labels(.COUNT,2)=m.Field
					.Labels(.COUNT,3)=m.MyLabels
					.Labels(.COUNT,4)=m.TimeStamp
					.Labels(.COUNT,5)=EVALUATE(CONCAT(.UniqueIDList))
				ENDIF
			ENDSCAN
			=CLOSE(.LabelsTable)
		ENDWITH
		SELECT(lnSelect)
		GO lnRecno IN (.NativeCursor)

	FUNCTION EditLabel
		LPARAMETERS loColumn
		LOCAL ID, 	lcField, lcOldValue, lcValue, 	;
			llNew, 	;
			lnIndex, lnLine, lnRecno, 	;
			loColumn
		WITH THIS
			IF TYPE('loColumn.Name')#'C'
				FOR EACH loColumn IN .MyParent.logrd.COLUMNS
					IF .MyParent.logrd.ACTIVECOLUMN = loColumn.COLUMNORDER
						EXIT
					ENDIF
				NEXT
			ENDIF
			m.lcField = JustSource(loColumn)
			SELECT (.MyParent.logrd.RECORDSOURCE)
			m.lnRecno=RECNO(.MyParent.logrd.RECORDSOURCE)
			m.ID=ID

			lnIndex=0
			lcValue=''
			m.TimeStamp =DATETIME()
			llNew=.T.
			FOR lnLine=1 TO .COUNT
				IF lnRecno=.Labels(lnLine,1) AND m.lcField=.Labels(lnLine,2)
					lnIndex=lnLine
					lcValue=.Labels(lnLine,3)
					m.TimeStamp = .Labels(lnLine,4)
					llNew=.F.
					EXIT
				ENDIF
			NEXT
			lcOldValue = lcValue
			DO FORM EditLabel WITH lcValue TO lcValue
			IF lcOldValue == lcValue
				RETURN
			ENDIF
			IF EMPTY(lnIndex)
				.COUNT=.COUNT+1
				lnIndex=.COUNT
				DIMENSION .Labels(lnIndex,6)
				.Labels(lnIndex,1)=lnRecno
				.Labels(lnIndex,2)=m.lcField
				.Labels(lnIndex,5)=EVALUATE(CONCAT(.UniqueIDList,.MyParent.logrd.RECORDSOURCE))
				m.TimeStamp=DATETIME()
			ENDIF
			.Labels(lnIndex,3)=lcValue
			.Labels(lnIndex,4)=m.TimeStamp
			.Altered=.T.
		ENDWITH

ENDDEFINE

DEFINE CLASS LabelsMark AS IMAGE
	PICTURE = 'Xlmark1.gif'
	RECNO=0
	lnColumn=0
	MyParent=''
	MyLabel = ''
	lnIndex=0
	FUNCTION INIT
		THIS.VISIBLE=.T.

	FUNCTION MOUSELEAVE
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		IF TYPE('thisForm.Balloon.Title') = 'C'
			THISFORM.Balloon=.F.
		ENDIF
	FUNCTION CLICK

	FUNCTION MOUSEENTER
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		IF nButton=0
			=Balloon(THIS,THIS.MyLabel,'',10,1,5,-1)
		ENDIF

	FUNCTION RIGHTCLICK
		LOCAL lcTable
		IF MESSAGEBOX('  ?',1,'',7000)=1
			lcTable='labels\'+THIS.MyParent.LabelsTable
			IF NOT USED(THIS.MyParent.LabelsTable)
				USE (lcTable) IN 0
			ENDIF
			DELETE ALL IN (THIS.MyParent.LabelsTable)
			USE IN (THIS.MyParent.LabelsTable)
			THIS.MyParent.COUNT=0
			THIS.MyParent.MyParent.AFTERROWCOLCHANGE()
		ENDIF

	FUNCTION CLICK
		LOCAL lcOldValue, lcValue
		WITH THIS.MyParent
			lcValue=.Labels(THIS.lnIndex,3)
			lcOldValue = lcValue
			DO FORM EditLabel WITH lcValue TO lcValue
			IF lcOldValue == lcValue
				RETURN
			ENDIF
			.Labels(THIS.lnIndex,3)=lcValue
			.Labels(THIS.lnIndex,4)=DATETIME()
			.Altered=.T.
		ENDWITH
ENDDEFINE


DEFINE CLASS Patches AS CUSTOM
	UniqueID=''
	ColumnList='1,2'
	COLUMNCOUNT=0
	COUNT=0
	MyParent = .F.
	lnGrdTop = 0

	DIMENSION la(1)
	FUNCTION INIT
		WITH THIS
			IF EMPTY(.UniqueID)
				.UniqueID = SYS(2015)
			ENDIF
		ENDWITH
	FUNCTION ColumnList_assign
		LPARAMETERS vNewVal
		WITH THIS
			.ColumnList = m.vNewVal
			.COLUMNCOUNT=OCCURS(',',m.vNewVal)+1
			DIMENSION .la(MAX(1,.COLUMNCOUNT),7)
			STORE -1 TO .la
		ENDWITH

	FUNCTION BindPatches
		LPARAMETERS lnColumn, lnRelativeRow, luValue,lnGrdTop,lnLeft, lnWidth
		LOCAL lcName, lcTag, lnColumnIndex, lnLen, lnLine, 	lo
		WITH THIS
			IF TYPE('.MyParent.loForm.Name')#'C'
				RETURN 0
			ENDIF
			lcTag=''
			IF VARTYPE(lnColumn)='L'	&&  - 
				IF lnColumn			&& 
					STORE -1 TO .la
					lnLen=LEN(.UniqueID)
					FOR lnLine=1 TO .COUNT
						lcName=.UniqueID+ALLTRIM(STR(lnLine))
						.MyParent.loForm.REMOVEOBJECT(lcName)
					NEXT
					.COUNT=0
					RETURN 0
				ELSE			&& 
					FOR lnColumnIndex=1 TO .COLUMNCOUNT
						lo = .NewPatch(lnColumnIndex)
						IF TYPE('lo.name') # 'C'
							LOOP
						ENDIF
						lnRecno=IIF(EOF(lo.logrd.RECORDSOURCE) OR BOF(lo.logrd.RECORDSOURCE),0,RECNO(lo.logrd.RECORDSOURCE))
						lo.BIND( .la(lnColumnIndex,4), ;
							.lnGrdTop+ (.la(lnColumnIndex,1)-1)* .MyParent.logrd.ROWHEIGHT+1, ; && lnObjectTop
						.la(lnColumnIndex,5), ;
							.MyParent.logrd.ROWHEIGHT*.la(lnColumnIndex,3)-1, ;	&& lnObjectHeight. 
						.la(lnColumnIndex,7),	;
							.la(lnColumnIndex,1), ;	&&   ,    
						.MyParent.logrd.ACTIVEROW, lnColumnIndex ,.la(lnColumnIndex,3), 1, 		; &&      ,   
						totext(.la(lnColumnIndex,6)) , lcTag)	&&   (-     On_Patch 
						IF lnRecno>0
							GO lnRecno IN (lo.logrd.RECORDSOURCE)
						ENDIF
						lo.VISIBLE=.T.
					NEXT
					STORE -1 TO .la

				ENDIF
				RETURN 0
			ENDIF

			.lnGrdTop = lnGrdTop
			lnColumnIndex=At2(totext(lnColumn),.ColumnList)
			IF lnColumnIndex=0
				RETURN 0
			ENDIF


			IF .la(lnColumnIndex,1)=-1
				.la(lnColumnIndex,1) = lnRelativeRow
				.la(lnColumnIndex,2) = lnColumn
				.la(lnColumnIndex,3) = 1
				.la(lnColumnIndex,4) = lnLeft
				.la(lnColumnIndex,5) = lnWidth
				.la(lnColumnIndex,6) = luValue
				.la(lnColumnIndex,7) = RECNO(.MyParent.logrd.RECORDSOURCE)
				RETU
			ENDIF
			IF .la(lnColumnIndex,6) = luValue
				.la(lnColumnIndex,3) = .la(lnColumnIndex,3) + 1
				RETURN
			ENDIF
			lo=.NewPatch(lnColumnIndex)
*	 
			lcTag=''
			lnRecno=RECNO()
			lo.BIND( lnLeft, ;
				.lnGrdTop+ (.la(lnColumnIndex,1)-1)* .MyParent.logrd.ROWHEIGHT+1, ; && lnObjectTop
			lnWidth, ;
				.MyParent.logrd.ROWHEIGHT*.la(lnColumnIndex,3)-1, ;	&& lnObjectHeight. 
			.la(lnColumnIndex,7),	;	&& Recno()
			.la(lnColumnIndex,1), ;	&&   ,    
			.MyParent.logrd.ACTIVEROW, lnColumnIndex ,.la(lnColumnIndex,3), 1, 		; &&      ,   
			totext(.la(lnColumnIndex,6)) , lcTag)	&&   (-     On_Patch 
			lo.VISIBLE=.T.

			GO lnRecno
			.la(lnColumnIndex,1) = lnRelativeRow
			.la(lnColumnIndex,2) = lnColumn
			.la(lnColumnIndex,3) = 1
			.la(lnColumnIndex,6) = luValue
			RETURN 0
		ENDWITH

	FUNCTION NewPatch
		LPARAMETERS lnColumnIndex
		WITH THIS
			IF .la(lnColumnIndex,3)<0
				RETURN
			ENDIF
			.COUNT=.COUNT+1
			lcName=.UniqueID+totext(.COUNT)
			=Patch(.MyParent.loForm, lcName, .MyParent.logrd)
			lo=GETPEM(.MyParent.loForm, lcName)
			RETURN lo

		ENDWITH
	FUNCTION DESTROY
		CLEAR CLASS 'Patches'
		CLEAR CLASS 'Patch'

ENDDEFINE

DEFINE CLASS OneTimeTimer AS TIMER
	MyActivateSeconds=0
	lnLevel=0

	FUNCTION INIT
		LPARAMETERS lnLevel, lnActivateSeconds
		THIS.lnLevel = EVL(lnLevel,0)
		THIS.MyActivateSeconds=lnActivateSeconds
		THIS.INTERVAL=50

	FUNCTION KillMe
		TRY
			THIS.PARENT.REMOVEOBJECT(THIS.NAME)
		CATCH
		ENDTRY


	FUNCTION TIMER
		WITH THIS
			IF TYPE('.PARENT.Name')#'C'
				RETURN
			ENDIF

			IF .lnLevel#.PARENT.TimerLevel
				.ENABLED=.F.
				.KillMe()
				RETURN
			ENDIF
			IF .MyActivateSeconds > .PARENT.lnActiveSeconds
				.PARENT.SetMarks(,,,.lnLevel)
				.ENABLED=.F.
				.KillMe()
				RETURN
			ELSE
				.MyActivateSeconds=SECONDS()
				.PARENT.lnActiveSeconds=.MyActivateSeconds-0.005
			ENDIF
		ENDWITH
ENDDEFINE

FUNCTION ObjForm
	LPARAMETERS loObj
	LOCAL lnLine
	IF TYPE('loObj')#'O' OR UPPER(loObj.BASECLASS)='FORM'
		RETURN loObj
	ENDIF
	FOR lnLine=1 TO 20
		loObj=loObj.PARENT
		IF UPPER(loObj.BASECLASS)='FORM'
			EXIT
		ENDIF
	NEXT
	RETURN loObj



PROCEDURE GetGridRowCount
	LPARAMETERS logrd AS OBJECT, lnHeight AS INTEGER
	lnHeight=EVL(lnHeight, logrd.HEIGHT)
	RETURN (lnHeight - logrd.HEADERHEIGHT - ;
		IIF(INLIST(logrd.SCROLLBARS, 1, 3), SYSMETRIC(14) , 0) - 2) / ;
		logrd.ROWHEIGHT

FUNCTION JustSource		&&   CONTROLSOURCE     Lower
	LPARAMETERS lcSource
	IF TYPE('lcSource')='O'
		lcSource = lcSource.CONTROLSOURCE
	ENDIF

	IF '.' $ lcSource AND NOT '(' $ lcSource
		lcSource = JUSTEXT(lcSource)
	ENDIF
	RETURN LOWER(lcSource)

FUNCTION obj2Client
	LPARAMETERS loObj,lnPosition
	LOCAL lnColumn, lnGrdLeft, lnGridLeft, lnLeft, lnNext, lnRight, loNext
	IF VERSION(4)='09.00.0000.5815'	; && Service Pack 2
		AND LOWER(loObj.BASECLASS)='column'
		DO CASE
			CASE lnPosition=2 && Left
				RETURN OBJTOCLIENT(loObj,2) - OBJTOCLIENT(loObj.PARENT,2)
			CASE lnPosition=3 && Width
				lnGridLeft = OBJTOCLIENT(loObj.PARENT,2)
				lnLeft       = OBJTOCLIENT(loObj,2) - lnGridLeft
				IF lnLeft=0
					RETURN 0
				ENDIF
				lnColumn =  VAL(SUBSTR(loObj.NAME,7))
				IF lnColumn =loObj.PARENT.LOCKCOLUMNS
					lnGrdLeft=OBJTOCLIENT(loObj.PARENT,2)
					FOR lnNext= lnColumn +1 TO loObj.PARENT.COLUMNCOUNT
						IF OBJTOCLIENT(loObj.PARENT.COLUMNS(lnNext),2)>lnGrdLeft
							EXIT
						ENDIF
					NEXT
				ELSE
					lnNext = lnColumn +1
				ENDIF
				IF lnNext<=loObj.PARENT.COLUMNCOUNT
					loNext=loObj.PARENT.COLUMNS(lnNext)
					lnRight= OBJTOCLIENT(loNext,2)-loObj.PARENT.LEFT
					IF lnRight>0
						RETURN lnRight - lnLeft -  IIF(lnColumn=loObj.PARENT.LOCKCOLUMNS,2,1)
					ENDIF
				ENDIF
				lnRight= lnGridLeft + loObj.PARENT.WIDTH - IIF(loObj.PARENT.SCROLLBARS>1,SYSMETRIC(15),0) - 1
				RETURN lnRight - lnLeft - IIF(lnColumn=loObj.PARENT.LOCKCOLUMNS,2,1)
		ENDCASE
	ENDIF
	RETURN OBJTOCLIENT(loObj,lnPosition)

FUNCTION Equal
	LPARAMETERS lu1,lu2
	RETURN IIF(ISNULL(lu1) AND ISNULL(lu2),.T.,NVL(VARTYPE(lu1)=VARTYPE(lu2) AND lu1==lu2,.F.))

FUNCTION On_CtrlZ
	IF TYPE([_Screen.ActiveForm.ActiveControl.aLaXl.Name])#'C' OR ;
			EMPTY(_SCREEN.ACTIVEFORM.ACTIVECONTROL.RELATIVEROW)
		RETURN
	ENDIF
	_SCREEN.ACTIVEFORM.ACTIVECONTROL.aLaXl.Ctrlz()

FUNCTION On_F10
	IF TYPE([_Screen.ActiveForm.ActiveControl.aLaXl.Name])#'C' OR ;
			EMPTY(_SCREEN.ACTIVEFORM.ACTIVECONTROL.RELATIVEROW) OR ;
			NOT _SCREEN.ACTIVEFORM.ACTIVECONTROL.aLaXl.UseLabels
		RETURN
	ENDIF
	_SCREEN.ACTIVEFORM.ACTIVECONTROL.aLaXl.loLabels.EditLabel()

FUNCTION CONCAT
	LPARAMETERS lcList, lcPrefix
	LOCAL lcConcat, lnLine
	lcPrefix=IIF(EMPTY(lcPrefix),'',lcPrefix+'.')
	lcConcat = ''
	FOR lnLine=1 TO ALINES(la,lcList,',')
		lcConcat = IIF(lnLine=1,'',lcConcat+'+') + [totext(] + lcPrefix + la(lnLine) +[)]
	NEXT
	RETURN lcConcat
FUNCTION At2
	LPARAMETERS lc,lcIn, llInclude, lcTab
	LOCAL la(1), lnLines, lnLine
	lnLines=ALINES(la,lcIn,IIF(TYPE('lcTab')='C',lcTab,','))
	IF llInclude
		FOR lnLine=1 TO lnLines
			IF lc $ la(lnLine)
				RETURN lnLine
			ENDIF

		NEXT
		RETURN 0
	ELSE
		RETURN ASCAN(la,lc)
	ENDIF
